//   Copyright 2012 Georg-August-Universität Göttingen, Germany
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

package de.ugoe.cs.autoquest.httpmonitor;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author Patrick Harms
 */
class DummyServlet extends HttpServlet {

    /**  */
    private static final long serialVersionUID = 1L;
    
    /** */
    private String query;
    
    /** */
    private String requestMessage;
    
    /** */
    private String responseMessage;

    /* (non-Javadoc)
     * @see org.mortbay.jetty.servlet.DefaultServlet#doGet(HttpServletRequest, HttpServletResponse)
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        query = request.getQueryString();
        requestMessage = AbstractTC.readStreamContentToString(request.getInputStream());
        
        System.err.println("responding on get with:   " + responseMessage);
        response.getOutputStream().write(responseMessage.getBytes());
    }

    /* (non-Javadoc)
     * @see org.mortbay.jetty.servlet.DefaultServlet#doPost(HttpServletRequest, HttpServletResponse)
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        query = request.getQueryString();
        requestMessage = AbstractTC.readStreamContentToString(request.getInputStream());
        
        System.err.println("responding on post with:  " + responseMessage);
        response.getOutputStream().write(responseMessage.getBytes());
    }

    /* (non-Javadoc)
     * @see org.mortbay.jetty.servlet.DefaultServlet#doTrace(HttpServletRequest, HttpServletResponse)
     */
    @Override
    protected void doTrace(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        query = request.getQueryString();
        requestMessage = AbstractTC.readStreamContentToString(request.getInputStream());
        
        System.err.println("responding on trace with: " + responseMessage);
        response.getOutputStream().write(responseMessage.getBytes());
    }

    /**
     * 
     */
    void setResponse(String responseMessage) {
        this.responseMessage = responseMessage;
    }

    /**
     * 
     */
    String getRequest() {
        return this.requestMessage;
    }

    /**
     * 
     */
    String getQuery() {
        return this.query;
    }
}